package com.iformall.controller.basic;

import com.iformall.controller.base.BaseController;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

import com.github.pagehelper.PageInfo;
import com.iformall.common.Result;
import com.iformall.common.ResultData;

import com.iformall.domain.po.WxCouponSendConfig;
import com.iformall.service.WxCouponSendConfigService;
import io.swagger.annotations.ApiImplicitParam;
import io.swagger.annotations.ApiImplicitParams;
import io.swagger.annotations.ApiOperation;

@RestController
@RequestMapping("wxCouponSendConfig")
public class WxCouponSendConfigController extends BaseController {
    private final Logger logger = LoggerFactory.getLogger(this.getClass());
    @Autowired
    private WxCouponSendConfigService wxCouponSendConfigService;

    @ApiOperation("分页列表接口")
    @GetMapping("list")
    @ApiImplicitParams({
            @ApiImplicitParam(name = "pageNum", value = "页数", dataType = "int", paramType = "query", required = true),
            @ApiImplicitParam(name = "pageSize", value = "每页条数", dataType = "int", paramType = "query", required = true)})
    public ResultData list(@ModelAttribute WxCouponSendConfig wxCouponSendConfig, Integer pageNum, Integer pageSize) {
        if (null == wxCouponSendConfig) wxCouponSendConfig = new WxCouponSendConfig();
        final PageInfo<WxCouponSendConfig> page = wxCouponSendConfigService.listAsPage(wxCouponSendConfig, pageNum, pageSize);
        return new ResultData(page);
    }

    @ApiOperation("新增接口(2)")
    @PostMapping("add")
    public ResultData add(@RequestBody WxCouponSendConfig wxCouponSendConfig) {
        //Assert.notNull(wxCouponSendConfig.getName(), "角色名不能为空");
        //Assert.isTrue(!checkUnique(sysRole.getName(), null), "重复的角色名");
        wxCouponSendConfigService.saveOrUpdate(wxCouponSendConfig);
        return new ResultData();
    }

    @ApiOperation("根据id更新接口")
    @PostMapping("update")
    public ResultData update(@RequestBody WxCouponSendConfig wxCouponSendConfig) {
        wxCouponSendConfigService.saveOrUpdate(wxCouponSendConfig);
        return new ResultData();
    }

    @ApiOperation("根据id删除接口")
    @GetMapping("/del")
    @ApiImplicitParam(name = "id", value = "id", dataType = "Long", paramType = "query", required = true)
    public ResultData delete(Long id) {
        wxCouponSendConfigService.deleteById(id);
        return new ResultData(Result.SUCCESS, "删除成功", null);
    }

    @ApiOperation("根据id查询接口")
    @GetMapping("/findById")
    @ApiImplicitParam(name = "id", value = "id", dataType = "Long", paramType = "query", required = true)
    public ResultData findById(Long id) {
        return new ResultData(Result.SUCCESS, "查询成功", wxCouponSendConfigService.getById(id));
    }


}
